Index: uspace/lib/block/libblock.c
===================================================================
--- uspace/lib/block/libblock.c	(revision e950803ed2d515a08b7d9fa5bb04ba2b26c41c99)
+++ uspace/lib/block/libblock.c	(revision bd813861801556b8db9bf68757dadd65653cf582)
@@ -294,8 +294,6 @@
 
 	/* Allow 1:1 or small-to-large block size translation */
-	if (cache->lblock_size % devcon->pblock_size != 0) {
-		free(cache);
+	if (cache->lblock_size % devcon->pblock_size != 0)
 		return ENOTSUP;
-	}
 
 	cache->blocks_cluster = cache->lblock_size / devcon->pblock_size;
@@ -438,5 +436,4 @@
 			if (!b->data) {
 				free(b);
-				b = NULL;
 				goto recycle;
 			}
@@ -566,5 +563,4 @@
 	assert(devcon);
 	assert(devcon->cache);
-	assert(block->refcnt >= 1);
 
 	cache = devcon->cache;
@@ -626,6 +622,6 @@
 			unsigned long key = block->lba;
 			hash_table_remove(&cache->block_hash, &key, 1);
+			free(block);
 			free(block->data);
-			free(block);
 			cache->blocks_cached--;
 			fibril_mutex_unlock(&cache->lock);
Index: uspace/lib/c/generic/async.c
===================================================================
--- uspace/lib/c/generic/async.c	(revision e950803ed2d515a08b7d9fa5bb04ba2b26c41c99)
+++ uspace/lib/c/generic/async.c	(revision bd813861801556b8db9bf68757dadd65653cf582)
@@ -294,6 +294,15 @@
 }
 
+/** Connection hash table removal callback function.
+ *
+ * This function is called whenever a connection is removed from the connection
+ * hash table.
+ *
+ * @param item Connection hash table item being removed.
+ *
+ */
 static void conn_remove(link_t *item)
 {
+	free(hash_table_get_instance(item, connection_t, link));
 }
 
@@ -638,5 +647,4 @@
 		ipc_answer_0(FIBRIL_connection->close_callid, EOK);
 	
-	free(FIBRIL_connection);
 	return 0;
 }
Index: uspace/srv/devman/devman.c
===================================================================
--- uspace/srv/devman/devman.c	(revision e950803ed2d515a08b7d9fa5bb04ba2b26c41c99)
+++ uspace/srv/devman/devman.c	(revision bd813861801556b8db9bf68757dadd65653cf582)
@@ -1063,7 +1063,7 @@
 	if (info != NULL) {
 		memset(info, 0, sizeof(dev_class_info_t));
-		link_initialize(&info->dev_classes);
-		link_initialize(&info->devmap_link);
-		link_initialize(&info->link);
+		list_initialize(&info->dev_classes);
+		list_initialize(&info->devmap_link);
+		list_initialize(&info->link);
 	}
 	
Index: uspace/srv/devmap/devmap.c
===================================================================
--- uspace/srv/devmap/devmap.c	(revision e950803ed2d515a08b7d9fa5bb04ba2b26c41c99)
+++ uspace/srv/devmap/devmap.c	(revision bd813861801556b8db9bf68757dadd65653cf582)
@@ -423,6 +423,5 @@
 	 */
 	list_initialize(&driver->devices);
-
-	link_initialize(&driver->drivers);
+	list_initialize(&(driver->drivers));
 	
 	fibril_mutex_lock(&drivers_list_mutex);
@@ -539,6 +538,6 @@
 	}
 	
-	link_initialize(&device->devices);
-	link_initialize(&device->driver_devices);
+	list_initialize(&(device->devices));
+	list_initialize(&(device->driver_devices));
 	
 	/* Check that device is not already registered */
@@ -943,6 +942,6 @@
 	}
 	
-	link_initialize(&device->devices);
-	link_initialize(&device->driver_devices);
+	list_initialize(&(device->devices));
+	list_initialize(&(device->driver_devices));
 	
 	/* Get unique device handle */
Index: uspace/srv/fs/devfs/devfs_ops.c
===================================================================
--- uspace/srv/fs/devfs/devfs_ops.c	(revision e950803ed2d515a08b7d9fa5bb04ba2b26c41c99)
+++ uspace/srv/fs/devfs/devfs_ops.c	(revision bd813861801556b8db9bf68757dadd65653cf582)
@@ -130,5 +130,4 @@
 {
 	devfs_node_t *node = (devfs_node_t *) pfn->data;
-	int ret;
 	
 	if (node->handle == 0) {
@@ -146,7 +145,6 @@
 				
 				if (str_cmp(devs[pos].name, component) == 0) {
-					ret = devfs_node_get_internal(rfn, DEV_HANDLE_NAMESPACE, devs[pos].handle);
 					free(devs);
-					return ret;
+					return devfs_node_get_internal(rfn, DEV_HANDLE_NAMESPACE, devs[pos].handle);
 				}
 			}
@@ -164,7 +162,6 @@
 				for (pos = 0; pos < count; pos++) {
 					if (str_cmp(devs[pos].name, component) == 0) {
-						ret = devfs_node_get_internal(rfn, DEV_HANDLE_DEVICE, devs[pos].handle);
 						free(devs);
-						return ret;
+						return devfs_node_get_internal(rfn, DEV_HANDLE_DEVICE, devs[pos].handle);
 					}
 				}
@@ -187,7 +184,6 @@
 			for (pos = 0; pos < count; pos++) {
 				if (str_cmp(devs[pos].name, component) == 0) {
-					ret = devfs_node_get_internal(rfn, DEV_HANDLE_DEVICE, devs[pos].handle);
 					free(devs);
-					return ret;
+					return devfs_node_get_internal(rfn, DEV_HANDLE_DEVICE, devs[pos].handle);
 				}
 			}
